/* Copyright (c) 1992 The Geometry Center; University of Minnesota
   1300 South Second Street;  Minneapolis, MN  55454, USA;
   
This file is part of geomview/OOGL. geomview/OOGL is free software;
you can redistribute it and/or modify it only under the terms given in
the file COPYING, which you should have received along with this file.
This and other related software may be obtained via anonymous ftp from
geom.umn.edu; email: software@geom.umn.edu. */

/*
 * Authors: Charlie Gunn, Stuart Levy, Tamara Munzner, Mark Phillips,
 * Nathaniel Thurston
 */

#include "commentP.h"

GeomClass *CommentClass = NULL;

int CommentPresent = 1;

static char commentName[] = "comment";


char *
CommentName()
{
	return commentName;
}
/* Comments should NOT be pickable... Mon Jun 20 19:46:55 1994 TMM */
static Geom *
CommentPick(Geom *g, Pick *p, Appearance *ap, Transform T)
{
 return NULL;
}

GeomClass *
CommentMethods()
{
    if( !CommentClass ) {
	CommentClass = GeomClassCreate(commentName);
	
	CommentClass->name = CommentName;
        CommentClass->methods = (GeomMethodsFunc *)CommentMethods;
        CommentClass->create = (GeomCreateFunc *)CommentCreate;
	CommentClass->Delete = (GeomDeleteFunc *)CommentDelete;
	CommentClass->copy = (GeomCopyFunc *)CommentCopy;
	CommentClass->pick = (GeomPickFunc *)CommentPick;
	CommentClass->import = CommentImport;
	CommentClass->export = (GeomExportFunc *)CommentExport;
    }

    return CommentClass;
}
